#include "Token.hpp"

#include "Error.hpp"

#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <assert.h>

namespace SoftWire
{
	Token::Token()
	{
	}

	Token::~Token()
	{
	}

	bool Token::isEndOfLine() const
	{
		return !isIdentifier() &&
		       !isConstant() &&
		       !isPunctuator();
	}

	bool Token::isIdentifier() const
	{
		return false;
	}

	bool Token::isConstant() const
	{
		return false;
	}

	bool Token::isPunctuator() const
	{
		return false;
	}

	const char *Token::getString() const
	{
		return "";
	}

	char Token::getChar() const
	{
		return '\0';
	}

	int Token::getValue() const
	{
		return 0;
	}

	Identifier::Identifier(const char *string)
	{
		this->string = strdup(string);
	}

	Identifier::~Identifier()
	{
		delete[] string;
	}

	bool Identifier::isIdentifier() const
	{
		return true;
	}

	const char *Identifier::getString() const
	{
		return string;
	}

	Constant::Constant(int value)
	{
		this->value = value;
	}

	bool Constant::isConstant() const
	{
		return true;
	}

	int Constant::getValue() const
	{
		return value;
	}

	Punctuator::Punctuator(char c)
	{
		this->c = c;
	}

	bool Punctuator::isPunctuator() const
	{
		return true;
	}

	char Punctuator::getChar() const
	{
		return c;
	}
}